'Program demonstrira prikaz, kot ura
'Jumper pri PortC moramo odklopiti
'vtakniti moramo 32.768 kHz kvarc v podnoje
'Mega32 dela na notranjem 8 MHz oscilatorju 


$regfile = "m32def.dat"                                     ' specify the used micro

$crystal = 8000000                                          ' used crystal frequency

$baud = 9600                                                ' use baud rate

$hwstack = 62                                               ' default use 32 for the hardware stack

$swstack = 50                                               ' default use 10 for the SW stack

$framesize = 60



Config Clock = Soft

_sec = 56 : _min = 59 : _hour = 18                          ' Zacetno nastavljanje ure
Enable Interrupts

Dim Sek As Byte , Mi As Byte , Ho As Byte
Dim Sek_par As Byte , Parnepar As Bit , I1 As Byte          'pomozna spr., parnepar=0>>parno st.; =1>> neparno st.
Dim I As Word , N(4) As Byte , V As Byte , C As Byte , Z As Byte

Ledica Alias Porta.0
Config Ledica = Output

Config Lcdpin = Pin , Db4 = Porta.4 , Db5 = Porta.5 , Db6 = Porta.6 , Db7 = Porta.7 , E = Porta.2 , Rs = Porta.1
Config Lcd = 16 * 2
Config Lcdbus = 4
Cls



Const Adapter = 0                                           '=0>>normalno; =1>> adapter MegaPin prg.


#if Adapter = 0
Config Portc = Output
Portc = 0


Strobe Alias Portc.2                                        'pin 1 CD4094
Dat Alias Portc.1                                           'pin 2 CD4094
Clk Alias Portc.0                                           'pin 3 CD4094
Config Pinb.0 = Input
Config Pinb.1 = Input
Portb.0 = 1
Portb.1 = 1

#else

Strobe Alias Portd.7                                        'pin 1 CD4094
Dat Alias Portd.6                                           'pin 2 CD4094
Clk Alias Portd.5                                           'pin 3 CD4094

Config Portb.0 = Input
Config Portb.1 = Input
Portb.0 = 1
Portb.1 = 1


#endif


'Config Pind.0 = Input
'Config Pind.1 = Input
'Portd.0 = 1
'Portd.1 = 1


Sek = _sec
Mi = _min
Ho = _hour

If _min < 10 Then
   N(3) = 1
   N(4) = Lookup(_min , Dta)

   Else

   Z = _min / 10
   N(3) = Lookup(z , Dta2)
   Z = Z * 10
   N(4) = _min - Z
   Z = N(4)
   N(4) = Lookup(z , Dta)
End If

If _hour < 10 Then
   N(1) = 1
   N(2) = Lookup(_hour , Dta1)

   Else

   Z = _hour / 10
   N(1) = Lookup(z , Dta)
   N(2) = Z * 10
   Z = _hour - N(2)
   N(2) = Lookup(z , Dta1)
End If
Gosub 4094
Config Portb = Output

'Config Portb.0 = Input
'Config Portb.1 = Input


'Do
If Pinb.0 = 0 Then Gosub Raste_i                            ', Sub
If Pinb.1 = 0 Then Gosub Pada_i

'Gosub Raste_i
'I = 129
'For I = 0 To 250
N(4) = 129                                                  'prvi displej z desne strani (enice)
N(3) = 129
N(2) = 129
N(1) = 129                                                  'prvi displej z leve (tisocice)
Gosub 4094
Waitms 100
'Next

'Loop


Do
Locate 1 , 1
Lcd "min=" ; _min ; " "
Lcd "hour=" ; _hour ; "  "

Locate 2 , 1
Lcd "_sec=" ; _sec ; "  "

Ledica = _sec

   If Parnepar = 1 Then
      Portb = 0
      Else
      Portb = 255
   End If


   Gosub Par_nepar                                          'ugotavljamo, ali je sek par/nepar zato, da utripa segment

  ' #if Adapter = 0                                          '0= Vladotova nastavitev

  ' Debounce Pind.5 , 0 , Minute_plus , Sub
  ' Debounce Pind.6 , 0 , Ure_plus , Sub
  ' #else
   Debounce Pinb.0 , 0 , Minute_plus , Sub
   Debounce Pinb.1 , 0 , Ure_plus , Sub
  ' #endif

'If _min <> Mi Then   'to je dodano zato, da se displej spremeni samo ob spremembi minut, ce tega ne rabimo izklopimo
      Sek = _sec : Mi = _min : Ho = _hour
      If _min < 10 Then

'      If Ledica = 1 Then
         N(3) = 129
'         Else
'         N(2) = 129
'         End If

         N(4) = Lookup(_min , Dta)
         Else
         Z = _min / 10

'      If Ledica = 1 Then
         N(3) = Lookup(z , Dta2)
'         Else
'         N(2) = Lookup(z , Dta)
'      End If

      Z = Z * 10
      N(4) = _min - Z
      Z = N(4)
      N(4) = Lookup(z , Dta)
  End If

   If _hour < 10 Then
      N(1) = 129
      If Parnepar = 0 Then
         N(2) = Lookup(_hour , Dta)
         Else
         N(2) = Lookup(_hour , Dta1)
      End If

      Else

      Z = _hour / 10
      N(1) = Lookup(z , Dta)
      N(2) = Z * 10
      Z = _hour - N(2)

      If Parnepar = 0 Then                                  'utripanje dec.pike
         N(2) = Lookup(z , Dta)
         Else
         N(2) = Lookup(z , Dta1)
      End If

   End If
Gosub 4094
'End If


Loop
End

Minute_plus:
Incr _min
_sec = 0
If _min = 60 Then
_min = 0
End If
Waitms 100
Return


Ure_plus:
Incr _hour
If _hour = 24 Then
_hour = 0
End If
 If _hour < 10 Then
  N(1) = 255
  N(2) = Lookup(_hour , Dta1)
  Else

  Z = _hour / 10
  N(1) = Lookup(z , Dta)
   N(2) = Z * 10
  Z = _hour - N(2)

  N(2) = Lookup(z , Dta1)
  End If
  Gosub 4094
  Waitms 150
Return


Par_nepar:
   Sek_par = _sec / 2
   Sek_par = Sek_par * 2
   If Sek_par = _sec Then
      Parnepar = 1
      Else
      Parnepar = 0
   End If
Return



4094:

  Set Strobe                                                'omogocimo vpis
  For V = 1 To 4                                            'tevilo zaporedno vezanih displejev
  For C = 0 To 7                                            'posamezni biti spremenljivke
  Dat = N(v).c
    Set Clk
     Reset Clk
     Next
  Next
  Reset Strobe                                              'spremembe na vhodu ne vplivajo na izhod
  Return



Raste_i:
Incr I
Return

Pada_i:
Decr I
Return



Dta:
Data 129 , 183 , 194 , 146 , 180 , 152 , 136 , 179 , 128 , 144 , 255

'Data 129 , 237 , 67 , 73 , 45 , 25 , 17 , 205 , 1 , 9 , 254 , 255
'     0     1     2    3    4    5    6     7    8   9    .    off

Dta1:
Data 1 , 55 , 66 , 18 , 52 , 24 , 8 , 49 , 0 , 16 , 255     's piko spodaj desno

'Data 128 , 236 , 66 , 72 , 44 , 24 , 16 , 204 , 0 , 8 , 254 , 255
'     0.     1.   2.   3.   4.   5.   6.    7.   8.  9.  .     off


Dta2:
Data 129 , 183 , 194 , 146 , 180 , 152 , 136 , 179 , 128 , 144 , 255

'Data 1 , 109 , 66 , 72 , 44 , 24 , 16 , 77 , 0 , 8 , 254 , 255       'pika zgoraj levo